# Static websites are awesome. 

This is a fact: Static websites with no backend server are the cheapest, fastest,
and most secure websites out there.  You can compress things to the max,
cache them on a CDN distributed across the entire world, and guarantee
the fastest page loads time for your users.

If you are starting out developing a website or a web based application, constraining yourself to
keeping as much of your user facing web assets static will pay off. 

### Dynamic sites are practical 

But a static HTML only website with no backend or content management just doesn't suit the needs of most people, so people
turn to hosted solutions like Wordpress or Drupal, maybe they develop their own Rails app.  

The problem with dynamic sites powered by servers and application code and databases is you need to scale them, 
secure them, host them, or hire people to do those things for you.  Or you can pay for hosting for some generic 
content management platform, but you'll be constrained by these platforms and limited in the ways you can customize them.

### Skypager is the best of both worlds

If we eliminate the sites that developers make for themselves and for
other developers, most dynamic websites are going to be relying on content that
comes from people who aren't developers.  Whether that is blog posts,
marketing copy, landing pages, images, videos, or a large dataset which
contains records that will be represented by their own URL.

What tools are our non-developer teammates already using? They're using Dropbox, Google
Drive, Excel Spreadsheets, Word Documents, Photos, Videos, and things of
that nature.

Skypager provides ways to sync up with these other tools, and regenerate
your site's content whenever changes are made to these file systems.  

This opens up a lot of interesting possibilities for a wide range of
different kinds of websites, and ways of collaborating with people to
build them.

Best of all, you get the complete control and freedom provided to
you by the Ruby programming language and the many great site template authoring
tools provided by the community.

### What about user generated content?

Serverless apps which rely on storing and user generated content will need to get
creative with how they handle these requirements. When you are constraining yourself to
using a static site, this is one of the tradeoffs.    

We have a number of guides and examples for how you can accomplish this.  Coming soon.

### Hassle free deployment, DNS Configuration, and CDN hosting setup

Skypager automates all of the boring but necessary steps that somebody
needs to take if they wanted to configure their own Static website
hosting using Amazon S3, Cloudfront, and it even takes care of the DNS configuration
you'll need to do to make this setup work on your own domain.

### Sync with Dropbox, Google Drive, and Github

Store your source code on Github so your developer can work on it.  

Store your photo library on Dropbox or Google Drive so your designer 
and photographer can manage those assets using the tools they work with. 

Store an excel spreadsheet containing all of your product information on Dropbox, 
or in a Google spreadsheet, so people from your business team can manage
that content.

Skypager will make sure these external sources of content are always
available, and incorporate them into the latest build of the site.

### Powered by Middleman

Skypager is an extension to the [Middleman](http://middlemanapp.com) static site generator.
Middleman allows for you to develop your site using templates, and
enhanced CSS and Javascript authoring languages like Sass, Less,
or Coffeescript.

### Getting Started: Standalone Mode

Skypager in standlone mode is what you would want to use if you are
working on a single site, and you are comfortable with the command line
and ruby.  Instructions for doing this can be found in our [Getting
Started Guide](https://github.com/architects/skypager)

### The Skypager Build Server

If you are managing a large number of Skypager sites, and would like to set it
up so that all of your sites stay up to date and in sync, you can run your
own instance of the Skypager Build Server.

The build server will do things like: accept webhooks from Github,
Dropbox, or Google Drive, which will happen whenever content changes.  

This will trigger a re-build of your site, and the updated content gets automatically pushed
to the hosting environment and to the CDN.

### Skypager.io: Hosted option with a Web UI

The easiest way to use Skypager in production is to subscribe to the Skypager.io
hosting service, which provides you with a web based front end for
managing all of your sites and handles all of the hosting service
configuration and such for you.  

Just point us to the source code, whether it is on Dropbox or Github, 
and use the rest of the features which you can configure using our webfront end, or our
Command line interface (CLI).
