domain = Skypager::Domain.new("skypager.io", paths:{
  forgot_password: "/forgot.html",
  sign_in: "/sign-in.html",
  default: "/index.html",
  provider: "cloudfront",
  method: "signed_cookies",
  resources: [
    "bucket-1",
    "bucket-2"
  ]
})


# a request can be routed to an underlying cdn distribution
# based on subdomain, and things like that
domain.find_resource_method do |request|
  request.subdomain
end

# each domain can authorize requests however they want
domain.requests_are_authorized_by do |request|
  user = domain.find_user_for_request(request)
  user.can_perform_request?(request)
end

# each domain will have its own methods for mapping requests to actual identity
domain.find_user_method do |request|
  auth_token = request.env['X_AUTH_TOKEN']
  user_email = request.env['X_AUTH_EMAIL']

  User.where(email: user_email, auth_token: auth_token).first
end


